Macro TNP Solution: Difference between revisions

From FreeCAD Documentation
No edit summary
No edit summary
Line 11: Line 11:


[[File:TNP_solution.gif]]
[[File:TNP_solution.gif]]

File for testing has been uploaded at FreeCAD forum:
[https://forum.freecadweb.org/download/file.php?id=198537 TNP.FCStd]


==Solution description==
==Solution description==
Line 18: Line 21:


If you build object at another object, and also with Sketch
If you build object at another object, and also with Sketch
it is straightforward, because you know two things:
it is straightforward to solve, because you know two things:


* Points from Sketch is always part of the face below
# Points from Sketch is always part of the face below
* The Sketch and the face below are in the same plane
# The Sketch and the face below are in the same plane

To solve Topological Naming Problem problem you can:

'''Store the key before any operation:'''


You need only store the key before any operation. For this
You need only store the key before any operation. For this
example described at [[Topological_naming_problem|Topological Naming Problem]] page
example the object is at XY plane. So, I use Z axis value
from Sketch BoundBox center (s2.Shape.BoundBox.Center[2]).
the object is at XY plane. So, I use Z axis value from Sketch BoundBox center:

Before resize operation I store the value as a key.
{{MacroCode|code=
ad = FreeCAD.ActiveDocument
p2 = ad.Pad002
s2 = p2.Profile[0]
key = round(s2.Shape.BoundBox.Center[2], precision)
}}

'''Next search all faces for the stored key:'''

After the resize I search all faces for the stored key.
After the resize I search all faces for the stored key.

'''Final steps'''


At the end I assign the new face to the Sketch and recompute.
At the end I assign the new face to the Sketch and recompute.
To be honest, the most difficult part was to assign the face
To be honest, the most difficult part was to assign the face
to Sketch.Support, for me the syntax is mind-blowing ;-)
to Sketch.Support, for me the syntax is mind-blowing ;-)

'''Summary'''


In this example the plane is XY, but you can do exactly the
In this example the plane is XY, but you can do exactly the
same for other axes. Also you can choose other key.
same for other axes. Also you can choose other key. The same you
The same you can do for edges at Chamfer.
can do for edges at Chamfer or Fillets. This is already solved
This is already solved [https://github.com/dprojects/Woodworking Woodworking project]
at [https://github.com/dprojects/Woodworking Woodworking project] and is already available in its library.
and is already available in its library.


==Code==
==Code==

Revision as of 10:56, 16 August 2022

TNP_solution

Description
This is solution for Topological Naming Problem.

Macro version: 1.0
Last modified: 2022-08-16
Author: Dprojects
Author
Dprojects
Download
None
Links
Macro Version
1.0
Date last modified
2022-08-16
FreeCAD Version(s)
None
Default shortcut
None
See also
None

Description

File for testing has been uploaded at FreeCAD forum: TNP.FCStd

Solution description

This is solution for Topological Naming Problem described at: Topological Naming Problem

If you build object at another object, and also with Sketch it is straightforward to solve, because you know two things:

  1. Points from Sketch is always part of the face below
  2. The Sketch and the face below are in the same plane

To solve Topological Naming Problem problem you can:

Store the key before any operation:

You need only store the key before any operation. For this example described at Topological Naming Problem page the object is at XY plane. So, I use Z axis value from Sketch BoundBox center:

ad = FreeCAD.ActiveDocument
p2 = ad.Pad002
s2 = p2.Profile[0]
key = round(s2.Shape.BoundBox.Center[2], precision)

Next search all faces for the stored key:

After the resize I search all faces for the stored key.

Final steps

At the end I assign the new face to the Sketch and recompute. To be honest, the most difficult part was to assign the face to Sketch.Support, for me the syntax is mind-blowing ;-)

Summary

In this example the plane is XY, but you can do exactly the same for other axes. Also you can choose other key. The same you can do for edges at Chamfer or Fillets. This is already solved at Woodworking project and is already available in its library.

Code

__Title__="TNP_solution"
__Author__ = "Dprojects"
__Version__ = "1.0"
__Date__    = "2022-08-16"
__Comment__ = ""
__Web__ = "https://github.com/dprojects/Woodworking"
__Wiki__ = "https://wiki.freecadweb.org/TNP_solution"
__Icon__  = "TNP_solution.png"
__IconW__  = "TNP_solution.png"
__Help__ = "solution for Topological Naming Problem"
__Status__ = "stable"
__Requires__ = ""
__Communication__ = "http://www.freecadweb.org/wiki/index.php?title=User:Dprojects"

# ####################################################################
#
# This is solution for Topological Naming Problem described at 
# https://wiki.freecadweb.org/Topological_naming_problem
#
# MIT License
# 
# Copyright (c) 2022 Darek L github.com/dprojects
# 
# Permission is hereby granted, free of charge, to any 
# person obtaining a copy of this software and associated 
# documentation files (the "Software"), to deal in the 
# Software without restriction, including without limitation 
# the rights to use, copy, modify, merge, publish, distribute, 
# sublicense, and/or sell copies of the Software, and to permit 
# persons to whom the Software is furnished to do so, subject 
# to the following conditions:
# 
# The above copyright notice and this permission notice shall 
# be included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
# DEALINGS IN THE SOFTWARE.
# 
# ####################################################################

import FreeCAD

# this should be set according 
# FreeCAD user GUI precision settings
precision = 5

# global settings
ad = FreeCAD.ActiveDocument

# middle object to be resized
p1 = ad.Pad001
s1 = p1.Profile[0]

# top object bottom to store key
p2 = ad.Pad002
s2 = p2.Profile[0]

# ####################################################################
def getFaceIndex(iObj, iBB):
	
	index = 0	

	for f in iObj.Shape.Faces:

		index += 1
		bb = round(f.BoundBox.Center[2], precision)
		
		FreeCAD.Console.PrintMessage("\n")
		FreeCAD.Console.PrintMessage(index)
		FreeCAD.Console.PrintMessage(" ")
		FreeCAD.Console.PrintMessage(bb)

		if bb == iBB:
			FreeCAD.Console.PrintMessage(" <=== found")
			return index

	return -1

# ####################################################################
def makeTNP():

	# set key
	key = round(s2.Shape.BoundBox.Center[2], precision)

	# resize and cause TNP
	s1.setDatum(9, FreeCAD.Units.Quantity('350'))

	# recompute
	s1.recompute()
	p1.recompute()
	ad.recompute()

	FreeCAD.Console.PrintMessage("\n\n")
	FreeCAD.Console.PrintMessage("Stored key:"+str(key))
	FreeCAD.Console.PrintMessage("\n")

	# search all faces for solution
	solutionIndex = getFaceIndex(p1, key)
	solution = "Face"+str(solutionIndex)
	
	FreeCAD.Console.PrintMessage("\n\n")
	FreeCAD.Console.PrintMessage("Solution: "+solution)
	
	# set exact face to Sketch
	s2.Support = (p1, (solution,))
	ad.recompute()

# ####################################################################
def moveBack():

	s1.setDatum(9, FreeCAD.Units.Quantity('250'))
	s2.Support = (p1, ('Face13',))
	ad.recompute()

# ####################################################################
# main
# ####################################################################

# uncomment what you want
makeTNP()
#moveBack()

# ####################################################################